<template>
  <section id="arena-page">
    <div class="top-screen">
      <div class="text-box">
        <p></p>
      </div>
    </div>

    <div class="middle-screen"></div>

    <div class="bottom-screen">
      <div
        class="lobby"
        v-for="(lobby, index) in lobbies"
        :key="`lobby-${index}`"
        v-on:click="goToLobby(index)"
        v-bind:style="{ pointerEvents: lobby.players[0].name && lobby.players[1].name ? 'none': 'auto' }"
      >
        <div>
          <img
            class="player"
            :src=" require(`@/assets/character/man-simple.png`)"
            v-if="lobby.players[0].name"
          />
        </div>
        <div>
          <p v-if="lobby.players[0].name">{{lobby.players[0].name}}</p>
        </div>
        <div>
          <img class="pokeball" :src=" require(`@/assets/pokeball.png`)" />
        </div>
        <div>
          <p v-if="lobby.players[1].name">{{lobby.players[1].name}}</p>
        </div>
        <div>
          <img
            class="player"
            :src=" require(`@/assets/character/man-simple.png`)"
            v-if="lobby.players[1].name"
          />
        </div>
      </div>

      <button class="button is-danger is-large" @click="goback()">
        <span class="icon is-medium">
          <font-awesome-icon icon="backward" />
        </span>
        <span>Return</span>
      </button>
      <br />
      <br />
    </div>
  </section>
</template>

<script>
import router from "../router";
import WriteTextBox from "../helper/writeTextBox";

export default {
  name: "arena",
  data: function() {
    return {
      writeTextBox: null,
      lobbies : null
    };
  },
  methods: {
    goback() {      
      router.push("/");
    },
    goToLobby(index) {
      console.log(`/arena/${index}/selection`)
      this.$socket.emit('join-lobby',index);
    },
    getLobbies(){
      this.$socket.emit('get-lobbies');
    }
  },
  mounted() {
    this.writeTextBox = new WriteTextBox();
    this.writeTextBox.run([
      "Select a lobby"
    ]);
    this.$socket.on('lobbies', (data) => {
        this.lobbies = data
        console.log(this.lobbies)
    });
    this.$socket.on('lobby-joined', (id) => {
      console.log("lobby joined:"+ id)
      router.push(`/arena/${id}/selection`);
    });
    this.$socket.on('connection-denied', () => {
      console.log("connection denied")
    });
    this.getLobbies();
  },
  destroyed() {
    this.writeTextBox.destroy();
    this.$socket.off('lobbies');
    this.$socket.off('lobby-joined');
    this.$socket.off('connection-denied');
  }
};
</script>


<style scoped lang="scss">
#arena-page {
  .top-screen {
    background-image: url("~@/assets/background-figthroom.png") !important;
  }
  .bottom-screen {
    overflow-y: auto !important;
    scrollbar-width: thin;
    display: block !important;
    > div.lobby {
      margin-bottom: 0.5em;
      width: 100%;
      font-family: PokemonGb;
      padding: 0.85em 2em 0.85em 1em;
      text-align: left;
      height: calc(45px * 1.7);
      background-image: url("~@/assets/text-box3.png");
      background-repeat: no-repeat;
      background-size: 100% 100%;
      background-position: center center;
      cursor: pointer;

      display: flex;
      justify-content: space-between;
      flex-direction: row;
      &:last-child {
        margin-bottom: 0;
      }
      > div {
        &:nth-child(odd) {
          flex: 1;
        }
        &:nth-child(even) {
          flex: 3;
        }
        display: flex;
        justify-content: center;
        flex-direction: column;
        > p {
          text-align: center;
        }
        > img {
          margin: 0 auto;
          &.player {
            height: calc(23px * 2);
            width: calc(17px * 2);
          }
          &.pokeball {
            height: calc(14px * 2);
            width: calc(14px * 2);
          }
        }
      }
    }
  }
}
</style>
